#!perl 

$domain = "maofbiz2.migvan.co.il";

$AUX_LOGON = 0x01; #logon

$AUX_LOGONREPLY = "02"; #valid logon

$AUX_ERROR = "f0"; #Error

$AUX_NOACCESS = 0x02; #No Access

$AUX_DBERROR = 0x02; 

$DBERR_LOCKED = 0x0B; 

$AUX_LOGOFF = 0x03; #logoff

$AUX_OK = 0xEE; #logoff
##########################
#Removing Keys
##########################

$AUX_RELEASE_KEY = 0x1D; #Release key Sent from PC

$AUX_RELEASE_KEY_REPLY = 0x1E; #Release key

$AUX_KEYS_ACCESS_OK = "08"; #Access OK

$AUX_KEYS_ACCESS_SOME_OK = 0x09; #Access to some keys is OK

$AUX_KEYS_ACCESS_NONE = 0x0A; #No key access

#Removing Keys -> Key status

$KEY_IS_AVAILABLE = "00"; 
$KEY_ACCESS_DENIED = "01"; 
$NO_SUCH_KEY = "02";
$KEY_IS_OUT = "03";
$DUPLICATE_KEY_NO = "04";
$DUAL_ACCESS_KEY = "05";
$NO_DUAL_USER_ACCESS = "06";
$TRIPLE_ACCESS_KEY = "07";
$NO_TRIPLE_USER_ACCESS = "08";

#End key status

$UNKNOWN_USER_NUM = "03E8"; #returned if the key is out and ID of user not known.


$AUX_PROCEED = 0x21; # Sent by PC to KW after receiving Access OK from KW

$AUX_RELEASE_KEY_STATUS = 0x1F; #Release key status command

#Release key status KW options:
$AUX_KEY_RELEASED = "0B";
$AUX_DOOR_NOT_OPENED = "0C";
$AUX_KEY_NOT_REMOVED = "0D";
$AUX_KEY_NO_RECORD = "0E";
$AUX_SLAVE_BUSY = "0F"; #Key not communicating


#Ending the Release process
$AUX_RELEASE_HALT = 0x20; #Halt command
#options:
$AUX_KEY_REL_HALTED_ALARM = 0x10;
$AUX_KEY_REL_HALTED_SHORT = 0x11;
$AUX_KEY_REL_HALTED_USER = 0x12;
$AUX_KEY_REL_HALTED_DOOR = 0x13;
$AUX_KEY_REL_HALTED_UNK = 0x14;
$AUX_KEY_REL_DONE = 0x15;
$AUX_KEY_NOT_REL_DONE = 0x1A;

#####################
# Returning keys
#####################
$AUX_RETURN_KEYS_MANUAL = 0x27; #Sent from PC

$AUX_NONE_IN_USE = "29"; #No keys at use by user

$AUX_ERR_NO_OPEN_SLOTS = "16";
$AUX_ERR_NO_SUCH_BOX = "19";

$AUX_RETURN_KEY_INFO = "29";
$INITIAL_STATUS="01";

$AUX_RETURN_KEY_STATUS = "28"; #command
$AUX_RETURN_KEY_HALTED = "0A";

#options
$NO_ERR = "00";
$COMM_ERR = "02";
$DOOR_NOT_OPENED = "03";
$HALTED_BY_UESR = "04";
$All_KEYS_RETURNED = "05";
$NO_KEYS_RETURNED = "06";
$SLAVE_DIED = "07";
$SHORTED_KEY = "08";
$ILLEGAL_KEY = "09";

#############
#Alarms
#############

#alarm status:
$AUX_MORE_ALARMS = 26;
$AUX_NO_ALARMS = 27;
$AUX_LAST_ALARM = 28;

#PC commands
$AUX_GET_ALARMS = 0x39;
$AUX_CANCEL_ALARMS = 0x3C;


#Determining a keys in box
$AUX_GET_KEYS_IN_STATUS = 0x6B;




#CRC vars
@crcTbl =(0x0000,0xCC01,0xD801,0x1400,0xF001,0x3C00,0x2800,0xE401,0xA001,0x6C00,0x7800,0xB401,0x5000,0x9C01,0x8801,0x4400);
@header = (0xA5,0x5A);
@crc = (0x00,0x00);
%keys = (
	1=>0x01,
	2=>0x02,
	3=>0x03,
	4=>0x04,
);	
	
	
#Error messages	
$key_access_denied = "  ";
$no_such_key = "  ";
$key_is_out = "  ";
$no_keys_in_use = "  ";
$door_not_opened = "   ";
$all_keys_returned = "  ";
$no_keys_returned = "  ";
$bad_login = " ";