#!perl
print  "Content-Type: text/html\n\n";
# Written by:	Eric Yellin		Email: eric@migvan.co.il
# Date: 	16/11/02 1:33
# Last moification: 	16/11/02 1:33
#-------------------------------------------------------------------------------
# This script was created by Migvan Effect, all rights reserved.
# Its use is subject to the license agreement that can be found at the following
# URL:	http://www.migvan.co.il/license.txt
#-------------------------------------------------------------------------------

use Win32::SerialPort;
require "kw-vars.pl";
require "cgi-parse.pl";
&Parse_Data;
#foreach(keys(%CGI))
#{
#	print"<br>parametr: $_=$CGI{$_};<br>";
#}
#print "CGI{'serialPort'}=$CGI{'serialPort'}";


#initialize port
#$ob = Win32::SerialPort->new ("$CGI{'serialPort'}") || die;
$ob = Win32::SerialPort->new ('COM1') || die;

$ob->baudrate(9600);
$ob->parity("none");
$ob->parity_enable(1); 	# for any parity except "none"
$ob->databits(8);
$ob->stopbits(1);
$ob->write_settings;



$hiddenF = "<input type=hidden name=\"ID\" value=\"$CGI{'ID'}\">\n<input type=hidden name=\"username\" value=\"$CGI{'username'}\">\n<input type=hidden name=\"password\" value=\"$CGI{'password'}\">\n<input type=hidden name=\"session_id\" value=\"$CGI{'session_id'}\">\n";
my $key=$CGI{'key'};
#$CGI{'user'} = "001";
#$CGI{'pass'} = "1111";
#$CGI{'key'} = 4;
#$CGI{'act'} = "r";
foreach ($CGI{'user'},$CGI{'pass'},$CGI{'key'}) {
	$_=sprintf "%lx", $_; #get hex format
	#next we foemat each value as a 2 byte hex
	if (length $_ lt 2) {
		$_ = "000$_";
	}
	if (length $_ lt 3) {
		$_ = "00$_";
	}	
	if (length $_ lt 4) {
		$_ = "0$_";
	}	
}

#seperate each byte
$u1 = substr($CGI{'user'},0,2);
$u2 = substr($CGI{'user'},2,2);
$p1 = substr($CGI{'pass'},0,2);
$p2 = substr($CGI{'pass'},2,2);
$k1 = substr($CGI{'key'},0,2);
$k2 = substr($CGI{'key'},2,2);

#format into hex value
$u1 = eval("0x$u1");
$u2 = eval("0x$u2");
$p1 = eval("0x$p1");
$p2 = eval("0x$p2");
$k1 = eval("0x$k1");
$k2 = eval("0x$k2");
#Logon to KW
&send_data($AUX_LOGON,$u2,$u1,$p2,$p1);
if ($command eq $AUX_ERROR) { #incorrect logon
	&send_data($AUX_LOGOFF);
	$bad_login = 1;
	$err = "$bad_login";
	&return_data;
}
else {
	#Check alarms and stop them. Prevents alarm sounding when no key is taken.
	&send_data($AUX_GET_ALARMS);
	$aldata = $data1;
	while ($aldata eq $AUX_MORE_ALARMS) {
		&send_data($AUX_GET_ALARMS);
		$aldata = $data1;
		$al = eval("0x$data2");		
		&send_data($AUX_CANCEL_ALARMS,0x01,$al);
	}	
	if ($aldata eq $AUX_LAST_ALARM) {
		$al = eval("0x$data2");		
		&send_data($AUX_CANCEL_ALARMS,0x01,$al);
	}
}	

#Release key from KW
if ($CGI{'act'} eq "t") {
	&send_data($AUX_RELEASE_KEY,0x01,$k2,$k1);
	if ($data1 ne $AUX_KEYS_ACCESS_OK) {
		if ($data2 eq $KEY_ACCESS_DENIED) {
			$err = $key_access_denied;
		}	
		if ($data2 eq $NO_SUCH_KEY) {
			$err = $no_such_key;
		}	
		if ($data2 eq $KEY_IS_OUT) {
			$err = $key_is_out;
		}	
		&send_data($AUX_GET_KEYS_IN_STATUS);	
		$keys_in_status  = substr($r,12,20);
		&send_data($AUX_LOGOFF);
		&return_data;
	}	
	&send_data($AUX_PROCEED);
	&send_data($AUX_PROCEED);
}	
else { #return keys
	&send_data($AUX_RETURN_KEYS_MANUAL,0x01);
	if ($command eq $AUX_ERROR) { 
		$err = $no_keys_in_use;
		&send_data($AUX_GET_KEYS_IN_STATUS);	
		$keys_in_status  = substr($r,12,20);
		&send_data($AUX_LOGOFF);
		&return_data;
	}	
	&send_data($AUX_PROCEED);
	if ($command eq $AUX_RETURN_KEY_INFO) { #No key returned
		if($data1 eq $DOOR_NOT_OPENED) {
			$err = $door_not_opened;
		}	
		if($data1 eq $All_KEYS_RETURNED) {
			$err = $all_keys_returned;
		}	
		if($data1 eq $NO_KEYS_RETURNED) {
			$err = $no_keys_returned;
		}	
		&send_data($AUX_GET_KEYS_IN_STATUS);	
		$keys_in_status  = substr($r,12,20);
		&send_data($AUX_LOGOFF);
		&return_data;
	}	
	&send_data($AUX_PROCEED);
}	
&send_data($AUX_GET_KEYS_IN_STATUS);	
$keys_in_status  = substr($r,12,20);
&send_data($AUX_LOGOFF);
&return_data;

sub send_data {
	@data = @_;
	$bytecount = @data;
	&format_data;
	&writekw;
	&readkw;
}	
	
sub writekw {
	$output_string = pack("C*",@msg);
	$ob->write($output_string);
	$opstr = unpack("H*",$output_string);
	$opstr = substr($opstr,10,255);
	@msg=();
	
}
sub readkw {
	$ob->read_interval(100);
	($count, $result) = $ob->read(255);	
	$r = unpack("H*",$result);
	$command = substr($r,10,2);
	$data1 = substr($r,12,2);
	$data2 = substr($r,14,2);
}

sub format_data {
	push(@msg,@header,$bytecount,@crc,@data);
	$crc = &CRC16_calc(5,$msg[2],0xFFFF);	# 1st call
	$crc = &CRC16_calc(0,3,$crc);		# 2nd call
	$msg[3] = $crc & 0x00FF;		# LSB
	$msg[4] = $crc >> 8;			# MSB
}
sub CRC16_calc {
	local ($p,$size,$acc) = @_;
	while ($size--) {
		last if $size < 0;
		$d = $msg[$p];
		$p++;
		$acc = $crcTbl[($d ^ $acc) & 0x0F] ^ ($acc >> 4);
		$acc = $crcTbl[(($d >> 4) ^ $acc) & 0x0F] ^ ($acc >> 4);
	}
	return $acc;
}


	
		
sub return_data {
	print <<FORM;
<!-- FORM name=form1 action="$CGI{'carsMaof_url'}" method=post -->
<FORM name=form1 action="http://$domain/cgi-bin/kw.pl" method=post target="_top">
$hiddenF
<!--input type=hidden name="serialPort" value="$CGI{'serialPort'}"-->
<!--input type=hidden name="carsMaof_url" value="$CGI{'carsMaof_url'}"-->
<input type=hidden name="keys_in_status" value="$keys_in_status">
<input type=hidden name="err" value="$err">
<input type=hidden name="keys" value="1">
<input type=hidden name="ride" value="$CGI{'ride'}">
<input type=hidden name="car" value="$CGI{'car'}">
<input type=hidden name="key" value="$key">
<input type=hidden name="act" value="$CGI{'act'}">
</FORM>
<script>
document.form1.submit();
</script>
FORM
exit;
}